#!/usr/bin/perl

require "./configuration.pl";
require "accounts.pl";
require "filtermail.pl";
require "master.pl";
require "check.pl";
require "crypt.pl";

$| = 1;

$rcsid = '$Id: tts-join.cgi,v 2.9 1998/08/18 18:32:43 root Exp root $';

srand($$*11 ^ time);

($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time);
$stamp = sprintf "%02d%02d%02d", $year, $mon+1, $mday;

# tts-join.cgi - Create a new site record and provide setup instructions

if($ENV{REQUEST_METHOD} ne "POST") {
  print "Error: 501 Method Not Allowed\nContent-type: text/html\n\n";
print"<HTML><HEAD>
<TITLE>501 Method Not Implemented</TITLE>
</HEAD><BODY>
<H1>Method Not Implemented</H1>
Only POST method to tts-join.cgi is supported.<P>
</BODY></HTML>
";
  dodie("Called without POST method");
}

&ParseCGI;

$pwreq = 0;

print "Content-type: text/html\n\n";

foreach(@requiredtojoin) {
  if(/password/i) { $pwreq = 1; next; }
  push(@missing, $_) if($FORM{$_} eq "");
}

if($missing[0] ne "") {
  $missinglist = join(', ', @missing);
  $missinglist =~ s/, (\S+)$/ and $1/ if($missing[1] ne "");
  print "<HTML><HEAD>
<TITLE>Required Information Missing</TITLE>
</HEAD><BODY>
<H1>Required Information Missing</H1>
To process your submission, we must know your <B>$missinglist</B>.<P>
Please use your browser's <b>Back</b> button and complete those elements before resubmitting.<P>
</BODY></HTML>
";
  dodie("Form needs $missinglist to process join");
}

if($pwreq==1 && ($FORM{Password} ne $FORM{PasswordConfirmed} || $FORM{Password} eq "")) {
  print "<HTML><HEAD>
<TITLE>Password Not Confirmed</TITLE>
</HEAD><BODY>
<H1>Password Not Confirmed</H1>
To process your submission, we must have a <b>valid and confirmed Password</b>.<P>
Please use your browser's <b>Back</b> button, enter, and confirm your password before resubmitting.<P>
</BODY></HTML>
";
  dodie("Form needs matching password and confirmation to process join");
}

# Do length limit checks
foreach(keys %formlimits) { $FORM{$_} = substr($FORM{$_},0,$formlimits{$_}); }

if($FORM{RecordName} eq "") {
  # Choose a new account number (format: yymmdd-nn)
  $num = 0;

  opendir(DIR, $AccountsPath) || dodie("Can't read $AccountsPath: $!");
  @reclist = grep { /^${stamp}-\d+\.${AccountsSuffix}$/ } readdir(DIR);
  closedir DIR;

  foreach(@reclist) {
    push @nums, /-(\d+)/;                 # For sorting
    push @dates, /(\d+)-/;                # Purposes
  }

  @reclist = @reclist[ sort { $dates[$b] <=> $dates[$a] || $nums[$b] <=> $nums[$a] } 0..$#reclist ];

  if($reclist[0] ne "") {
    $reclist[0] =~ /^${stamp}-(\d+)\.${AccountsSuffix}$/;
    $num = $1 + 1;
  }
  $FORM{RecordName} = "$stamp-$num";
} else {
  # Crop and check record name for 'naughty characters'
  $FORM{RecordName} = substr($FORM{RecordName},0,10);
  if($FORM{RecordName} =~ /[^a-zA-Z0-9-]/) { # Only allow A-Z, a-z, 0-9 and - (these are safe)
    print "<HTML><HEAD>
<TITLE>Record Name Not Accepted</TITLE>
</HEAD><BODY>
<H1>Record Name Not Accepted</H1>
You have used an illegal character when choosing your Record Name.<P>
Legitemate characters are the letters A-Z and a-z, the numbers 0-9, and the dash (AKA
minus, or '-') character. Other punctuation or spaces/tabs are <B>Not Accepted</B>.<P>
Please use your browser's <B>Back</B> button and re-enter your Record Name.
</BODY></HTML>
";
    dodie("Form has a bad Record Name");
  }
  if(-e "$AccountsPath/$FORM{RecordName}.${AccountsSuffix}") { # Record already exists
    print "<HMTL><HEAD>
<TITLE>Record Name Already in Use</TITLE>
</HEAD><BODY>
<H1>Record Name Already in Use</H1>
The Record Name you have chosen is already in use by another account.<P>
Please use your browser's <B>Back</B> button and choose a new Record Name.<P>
If you are attempting to fix a fouled-up submission and know what your password is,
<A HREF='$CGIURL/tts-member.cgi'>Click Here</A> to edit your account.
</BODY></HTML>
";
    dodie("Record Name already taken");
  }
}

$FORM{Password} = ($pwreq==1) ? encrypt($FORM{Password}) : $MasterPassword;

foreach(keys %FORM) { 
  $FORM{$_} =~ s/^\s+//;
  if(/URL/) {
    $FORM{$_} = "" if($FORM{$_} =~ /\bnone\b/i);
    $FORM{$_} = "http://$FORM{$_}" if($FORM{$_} !~ /http:\/\//i && $FORM{$_} ne "");
    $FORM{$_} =~ s/\s//g;
  }
}

# Add checks for daily/total maximums and blacklist entry here
if(isExempted($FORM{SiteURL})!=1) {
  if(isBlacklisted($FORM{SiteURL})==1) {
    print "<HTML><HEAD>
<TITLE>SiteURL Not Welcome</TITLE>
</HEAD><BODY>
<H1>Site URL Not Welcome</H1>
Your Site's URL has been blacklisted and is not welcome to join this site.
</BODY></HTML>
";
    dodie("Blacklisted site: $FORM{SiteURL}");
  }
  grabrecords(1,0);
  if($TodayMaxJoin>0 || $TotalMaxJoin>0) {
    my @res = matchTopLevel($FORM{SiteURL});
    if($#res+1 >= $TodayMaxJoin && $TodayMaxJoin > 0) {
      $tj=0;
      foreach(@res) { $tj++ if($allrecords{$_}{Created} > time()-86400); }
      if($tj >= $TodayMaxJoin) {
        print "<HTML><HEAD>
<TITLE>Too Many Applications</TITLE>
</HEAD><BODY>
<CENTER><H1>Too Many Applications</H1>
Too many applications from this site have been made today. Wait for 24
hours and try resubmitting.
</BODY></HTML>
";
        dodie("Too many submissions today: $FORM{SiteURL}");
      }
    }
    if($#res+1 >= $TotalMaxJoin && $TotalMaxJoin > 0) {
      print "<HTML><HEAD>
<TITLE>Too Many Applications</TITLE>
</HEAD><BODY>
<H1>Too Many Applications</H1>
The number of applications for this site exceed site maximum. Please wait
until old accounts die or contact the webmaster at
<A HREF='mailto:$WebMasterEmail'>$WebMasterEmail</A> to remove the old
accounts.</BODY></HTML>
";
      dodie("Too many submissions: $FORM{SiteURL}");
    }
  }
}

putrecord(%FORM);
%FORM = getrecord("$stamp-$num");

@in = readarray($JoinTemplate);

if($#in < 0) {
  print "<HTML><HEAD>
<TITLE>TTS Application Confirmed</TITLE>
</HEAD><BODY bgcolor=#ffffff>
<CENTER><H1>TTS Application Confirmed</H1><HR>
<TABLE><TR><TD COLSPAN=2>Your order has been processed and a new account created for your site.</TD></TR>
<TR><TD>Your Account number:</TD><TD>$FORM{RecordName}</TD></TR></TABLE>
<H1>How to Attach to the TTS List</H1><HR></CENTER>
Put the following link on your site:<P>
<PRE>
<A HREF=\"$CGIURL/tts-in.cgi?$FORM{RecordName}\">&lt;A HREF=\"$CGIURL/tts-in.cgi?$FORM{RecordName}\"&gt;$SiteName&lt;/A&gt;</A>
</PRE>
</BODY></HTML>\n";
} else {
  print filtermail("@in\n", %FORM);
}   

@outmail = readarray($JoinMail);
exit if($MailMember == 0 || $#outmail < 1 || $FORM{Email} !~ /@/);
$mail = "From: $WebMasterEmail\nTo: $FORM{Email}\nReply-To: $WebMasterEmail\n";
$mail .= "Subject: Welcome, $FORM{Name}!\n" if($outmail[0] !~ /:/);
foreach(@outmail) { $mail .= $_; }
dodie("Can't open '$sendmail' to send mail!\n") if(!open(MAIL, "| $sendmail"));
print MAIL filtermail($mail, %FORM);
close MAIL;
